interface ExpressionBuilderVariable {
    variableId: number | string;
    name: string;
    value?: any;
}
interface ExpressionBuilderOption {
    suggestions?: 'up' | 'down';
    expression?: string;
    variables?: Array<ExpressionBuilderVariable>;
    functions?: any;
    preventWrongInput?: boolean;
    variableSpecialCharacters?: string[];
}
interface ExpressionBuilder {
    getExpression(): string;
    setExpression(expression: string | number | string[] | undefined): void;
    isValid(): boolean;
    parseExpression(expression: string): string;
    getInput(): string;
    getVariableById(variableId: number): string;
    setVariables(vars: Array<ExpressionBuilderVariable>): void;
    runExpression(): any;
}
interface JQuery {
    expressionBuilder(options?: ExpressionBuilderOption): ExpressionBuilder;
}
